Subject: bug#57613: closed (Re: bug#57613: grep man page tries to rewrite POSIX history)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 06 Sep 2022 19:29:02 +0000

Your bug report

#57613: grep man page tries to rewrite POSIX history

which was filed against the grep package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
57613: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=57613
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#57613: grep man page tries to rewrite POSIX history
From: Paul Eggert <[email-masked]>
To: Geoff Clare <[email-masked]>
Cc: [email-masked]
Date: Tue, 6 Sep 2022 14:28:12 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

On 9/6/22 07:28, Geoff Clare wrote:
> They were included in POSIX.2-1992 but marked as obsolescent.

Ouch, as I recall reading POSIX.2-1992 and seeing egrep and fgrep 
mentioned, but not as part of the standard. I guess I misread the 
standard. I am away from my printed copy and so cannot easily check this 
now.

I installed the attached which I hope clears this up.
From 216f754287f2123f45d274f0a003182524efd43d Mon Sep 17 00:00:00 2001
From: Paul Eggert <[email-masked]>
Date: Tue, 6 Sep 2022 13:52:12 -0500
Subject: [PATCH] Fix obsolescence doc for egrep, fgrep

---
 doc/grep.texi | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/doc/grep.texi b/doc/grep.texi
index 9f2f225..c371172 100644
--- a/doc/grep.texi
+++ b/doc/grep.texi
@@ -2105,9 +2105,9 @@ What happened to @command{egrep} and @command{fgrep}?
 that were the counterparts of the modern @samp{grep -E} and @samp{grep -F}.
 Although breaking up @command{grep} into three programs was perhaps
 useful on the small computers of the 1970s, @command{egrep} and
-@command{fgrep} were not standardized by POSIX and are no longer needed.
-In the current GNU implementation, @command{egrep} and @command{fgrep}
-issue a warning and then act like their modern counterparts;
+@command{fgrep} were deemed obsolescent by POSIX in 1992,
+removed from POSIX in 2001, deprecated by GNU Grep 2.5.3 in 2007,
+and changed to issue obsolescence warnings by GNU Grep 3.8 in 2022;
 eventually, they are planned to be removed entirely.
 
 If you prefer the old names, you can use use your own substitutes,
-- 
2.37.2

Subject: grep man page tries to rewrite POSIX history
From: Geoff Clare <[email-masked]>
To: [email-masked]
Date: Tue, 6 Sep 2022 13:28:37 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

The grep 3.8 man page at https://www.gnu.org/software/grep/manual/grep.html says, under "What happened to egrep and fgrep?":

egrep and fgrep were not standardized by POSIX

This is factually incorrect. They were included in POSIX.2-1992 but marked as obsolescent. When POSIX.2-1992 and POSIX.1-1996 were merged (along with the Single UNIX Specification) to form POSIX.1-2001, the obsolescent features from POSIX.2-1992 were removed.

Suggested fix - change:

egrep and fgrep were not standardized by POSIX and are no longer needed

to:

egrep and fgrep were marked obsolescent when they were standardized by POSIX in 1992 and were removed in the 2001 revision; they have long been deprecated by GNU.

(I have it second hand that the GNU deprecation occurred in 2007; you could give that date instead of saying "long" if you can confirm it.)